/*******************************************************************************
 * FoxSettingsUIKeyBindings generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSettingsUIKeyBindings extends FoxSettingsUIBase within FoxMenuUI
    native(UI)
    config(UI);

struct native KeyBindInfo
{
    var string CommandName;
    var name PrimaryKey;
    var name AlternateKey;
    var bool bLocked;

    structdefaultproperties
    {
        CommandName=""
        PrimaryKey=None
        AlternateKey=None
        bLocked=false
    }
};

var array<FoxDataProvider_CommandBinding> BindingProvider;
var int SelectedIndex;
var bool bChangePrimary;
var bool bIsBinding;
var bool bIsDirty;
var array<KeyBindInfo> CurrentKeyBindings;
var array<KeyBindInfo> OriginalKeyBindings;
var array<KeyBindInfo> DefaultKeyBindings;

function SetupSettingsScene()
{
    local KeyBindInfo NewKeyBindInfo;
    local int I;
    local FoxProfileSettingsPC PCProfileSettings;
    local FoxProfileSettingsOrbis OrbisProfileSettings;
    local array<FoxDataProvider_CommandBinding> CommandBindingsToEnd;

    Outer.as_addAdditionalButtonContainer("container", int(SettingsContainerProperties.X), int(SettingsContainerProperties.Y), 0, 0, 0, 100, "", "", SettingsContainerProperties.WidgetSpacing, SettingsContainerProperties.MaxListWidth, SettingsContainerProperties.MaxListHeight, true);
    as_addSettingsKeybindBG(0, 0);
    // End:0x143
    if(class'WorldInfo'.static.IsConsoleBuild(8))
    {
        Outer.as_addAdditionalButtonContainer("keybinds", 1000, -204, 0, 0, 0, 100, "", "", -2, 850, 305, true);
    }
    // End:0x18F
    else
    {
        Outer.as_addAdditionalButtonContainer("keybinds", 1000, -204, 0, 0, 0, 100, "", "", -2, 850, 400, true);
    }
    // End:0x297
    if(FoxProfileSettingsPC(Outer.Outer.PCOwner.ProfileSettings) != none)
    {
        PCProfileSettings = FoxProfileSettingsPC(Outer.Outer.PCOwner.ProfileSettings);
        BindingProvider = Outer.Outer.MenuItemsDataStore.GetKeyBindingProviders();
    }
    // End:0x39F
    else
    {
        // End:0x39F
        if(FoxProfileSettingsOrbis(Outer.Outer.PCOwner.ProfileSettings) != none)
        {
            OrbisProfileSettings = FoxProfileSettingsOrbis(Outer.Outer.PCOwner.ProfileSettings);
            BindingProvider = Outer.Outer.MenuItemsDataStore.GetControllerBindingProviders();
        }
        // End:0x39F
        else
        {
        }
    }
    I = 0;
    J0x3AA:
    // End:0x433 [Loop If]
    if(I < BindingProvider.Length)
    {
        // End:0x425
        if(BindingProvider[I].bLocked)
        {
            CommandBindingsToEnd.AddItem(BindingProvider[I]);
            BindingProvider.Remove(-- I, 1);
        }
        ++ I;
        // [Loop Continue]
        goto J0x3AA;
    }
    I = 0;
    J0x43E:
    // End:0x7F9 [Loop If]
    if(I < BindingProvider.Length)
    {
        NewKeyBindInfo.CommandName = BindingProvider[I].CmdName;
        NewKeyBindInfo.PrimaryKey = BindingProvider[I].GetKey(0);
        NewKeyBindInfo.AlternateKey = BindingProvider[I].GetKey(1);
        NewKeyBindInfo.bLocked = BindingProvider[I].bLocked;
        DefaultKeyBindings.AddItem(NewKeyBindInfo);
        NewKeyBindInfo.PrimaryKey = ((PCProfileSettings != none) ? PCProfileSettings.RetrieveKeyFromCommand(BindingProvider[I].CmdName, true) : OrbisProfileSettings.RetrieveButtonFromCommand(BindingProvider[I].CmdName));
        NewKeyBindInfo.AlternateKey = ((PCProfileSettings != none) ? PCProfileSettings.RetrieveKeyFromCommand(BindingProvider[I].CmdName, false) : OrbisProfileSettings.RetrieveButtonFromCommand(BindingProvider[I].CmdName));
        CurrentKeyBindings.AddItem(NewKeyBindInfo);
        OriginalKeyBindings.AddItem(NewKeyBindInfo);
        as_addKeyBind(BindingProvider[I].FriendlyName, BindingProvider[I].FriendlyToolTip, string(NewKeyBindInfo.PrimaryKey), string(NewKeyBindInfo.AlternateKey), BindingProvider[I].bLocked);
        ++ I;
        // [Loop Continue]
        goto J0x43E;
    }
    // End:0xC68
    if(CommandBindingsToEnd.Length > 0)
    {
        as_addKeybindDivider(0, 200, "KeyBindDividerLabel_X", "KeyBindings01Label", "KeyBindings02Label", true);
        Outer.as_addAdditionalButtonContainer("lockedkeybinds", 1000, 73, 0, 0, 0, 100, "", "", -2, 800, 170, true);
        I = 0;
        J0x8AD:
        // End:0xC68 [Loop If]
        if(I < CommandBindingsToEnd.Length)
        {
            NewKeyBindInfo.CommandName = CommandBindingsToEnd[I].CmdName;
            NewKeyBindInfo.PrimaryKey = CommandBindingsToEnd[I].GetKey(0);
            NewKeyBindInfo.AlternateKey = CommandBindingsToEnd[I].GetKey(1);
            NewKeyBindInfo.bLocked = CommandBindingsToEnd[I].bLocked;
            DefaultKeyBindings.AddItem(NewKeyBindInfo);
            NewKeyBindInfo.PrimaryKey = ((PCProfileSettings != none) ? PCProfileSettings.RetrieveKeyFromCommand(CommandBindingsToEnd[I].CmdName, true) : OrbisProfileSettings.RetrieveButtonFromCommand(CommandBindingsToEnd[I].CmdName));
            NewKeyBindInfo.AlternateKey = ((PCProfileSettings != none) ? PCProfileSettings.RetrieveKeyFromCommand(CommandBindingsToEnd[I].CmdName, false) : OrbisProfileSettings.RetrieveButtonFromCommand(CommandBindingsToEnd[I].CmdName));
            CurrentKeyBindings.AddItem(NewKeyBindInfo);
            OriginalKeyBindings.AddItem(NewKeyBindInfo);
            as_addKeyBind(CommandBindingsToEnd[I].FriendlyName, CommandBindingsToEnd[I].FriendlyToolTip, string(NewKeyBindInfo.PrimaryKey), string(NewKeyBindInfo.AlternateKey), CommandBindingsToEnd[I].bLocked);
            ++ I;
            // [Loop Continue]
            goto J0x8AD;
        }
    }
    //return;    
}

function ei_ResetToDefaults()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x58 [Loop If]
    if(I < CurrentKeyBindings.Length)
    {
        CurrentKeyBindings[I] = DefaultKeyBindings[I];
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    UpdateAllBindings();
    //return;    
}

function ei_RevertChanges(optional bool bSkipUpdate)
{
    local int I;

    I = 0;
    J0x0C:
    // End:0x59 [Loop If]
    if(I < CurrentKeyBindings.Length)
    {
        CurrentKeyBindings[I] = OriginalKeyBindings[I];
        ++ I;
        // [Loop Continue]
        goto J0x0C;
    }
    // End:0x72
    if(!bSkipUpdate)
    {
        UpdateAllBindings();
    }
    //return;    
}

function UpdateAllBindings()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xA9 [Loop If]
    if(I < CurrentKeyBindings.Length)
    {
        as_updateBind(I, true, string(CurrentKeyBindings[I].PrimaryKey));
        as_updateBind(I, false, string(CurrentKeyBindings[I].AlternateKey));
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

event bool SetNewKeyBinding(name InputKey)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x335 [Loop If]
    if(I < CurrentKeyBindings.Length)
    {
        // End:0x1A5
        if(CurrentKeyBindings[I].PrimaryKey == InputKey)
        {
            // End:0x83
            if(CurrentKeyBindings[I].bLocked)
            {
                return false;
            }
            // End:0x11C
            if(bChangePrimary)
            {
                CurrentKeyBindings[I].PrimaryKey = CurrentKeyBindings[SelectedIndex].PrimaryKey;
                as_updateBind(I, true, string(CurrentKeyBindings[SelectedIndex].PrimaryKey));
            }
            // End:0x1A5
            else
            {
                CurrentKeyBindings[I].PrimaryKey = CurrentKeyBindings[SelectedIndex].AlternateKey;
                as_updateBind(I, false, string(CurrentKeyBindings[SelectedIndex].AlternateKey));
            }
        }
        // End:0x327
        if(CurrentKeyBindings[I].AlternateKey == InputKey)
        {
            // End:0x205
            if(CurrentKeyBindings[I].bLocked)
            {
                return false;
            }
            // End:0x29E
            if(bChangePrimary)
            {
                CurrentKeyBindings[I].AlternateKey = CurrentKeyBindings[SelectedIndex].PrimaryKey;
                as_updateBind(I, true, string(CurrentKeyBindings[SelectedIndex].PrimaryKey));
            }
            // End:0x327
            else
            {
                CurrentKeyBindings[I].AlternateKey = CurrentKeyBindings[SelectedIndex].AlternateKey;
                as_updateBind(I, false, string(CurrentKeyBindings[SelectedIndex].AlternateKey));
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    // End:0x375
    if(bChangePrimary)
    {
        CurrentKeyBindings[SelectedIndex].PrimaryKey = InputKey;
    }
    // End:0x3A5
    else
    {
        CurrentKeyBindings[SelectedIndex].AlternateKey = InputKey;
    }
    as_updateBind(SelectedIndex, bChangePrimary, string(InputKey));
    bIsBinding = false;
    return true;
    //return ReturnValue;    
}

function ApplyChanges()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x24C [Loop If]
    if(I < CurrentKeyBindings.Length)
    {
        // End:0x112
        if(FoxProfileSettingsOrbis(Outer.Outer.PCOwner.ProfileSettings) != none)
        {
            Outer.Outer.PCOwner.SetOrbisKeyBinding(CurrentKeyBindings[I].CommandName, CurrentKeyBindings[I].PrimaryKey);
        }
        // End:0x23E
        else
        {
            Outer.Outer.PCOwner.SetPCKeyBinding(CurrentKeyBindings[I].CommandName, CurrentKeyBindings[I].PrimaryKey, true);
            Outer.Outer.PCOwner.SetPCKeyBinding(CurrentKeyBindings[I].CommandName, CurrentKeyBindings[I].AlternateKey, false);
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    Outer.Outer.PCOwner.ApplyControlsSettings();
    //return;    
}

event CloseDialogBox()
{
    // End:0x82
    if(Outer.Outer.DialogBox != none)
    {
        Outer.Outer.DialogBox.CloseDialog();
    }
    //return;    
}

function ei_bindPrimary(string Index)
{
    local DialogBoxProperties Properties;

    bChangePrimary = true;
    bIsBinding = true;
    SelectedIndex = int(Index);
    Properties.DialogType = 9;
    Properties.TitleText = Outer.LocalizeMenuString(((class'WorldInfo'.static.IsConsoleBuild(8)) ? "PrimaryKeyBindingTitle_X" : "PrimaryKeyBindingTitle"));
    Properties.BodyText = Outer.LocalizeMenuString(((class'WorldInfo'.static.IsConsoleBuild(8)) ? "PrimaryKeyBindingMessage_X" : "PrimaryKeyBindingMessage")) @ BindingProvider[SelectedIndex].FriendlyName;
    Properties.OnDialogButtonPressed = OnMessageBoxClose;
    Outer.Outer.ShowDialogBox(Properties);
    //return;    
}

function ei_bindAlt(string Index)
{
    local DialogBoxProperties Properties;

    bChangePrimary = false;
    bIsBinding = true;
    SelectedIndex = int(Index);
    Properties.DialogType = 9;
    Properties.TitleText = Outer.LocalizeMenuString("SecondaryKeyBindingTitle");
    Properties.BodyText = Outer.LocalizeMenuString("SecondaryKeyBindingMessage") @ BindingProvider[SelectedIndex].FriendlyName;
    Properties.OnDialogButtonPressed = OnMessageBoxClose;
    Outer.Outer.ShowDialogBox(Properties);
    //return;    
}

function OnMessageBoxClose(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    bIsBinding = false;
    //return;    
}

function bool HasSettingsChanged()
{
    local int I;

    // End:0x1B
    if(bIsDirty)
    {
        bIsDirty = false;
        return true;
    }
    I = 0;
    J0x26:
    // End:0xF2 [Loop If]
    if(I < CurrentKeyBindings.Length)
    {
        // End:0xE4
        if((CurrentKeyBindings[I].PrimaryKey != OriginalKeyBindings[I].PrimaryKey) || CurrentKeyBindings[I].AlternateKey != OriginalKeyBindings[I].AlternateKey)
        {
            return true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x26;
    }
    return false;
    //return ReturnValue;    
}

function ConfirmSettingsValidity()
{
    local int I, J;

    I = 0;
    J0x0B:
    // End:0xD6 [Loop If]
    if(I < CurrentKeyBindings.Length)
    {
        // End:0xC8
        if(CurrentKeyBindings[I].PrimaryKey == 'None')
        {
            ei_ResetToDefaults();
            J = 0;
            J0x6C:
            // End:0xB9 [Loop If]
            if(J < CurrentKeyBindings.Length)
            {
                OriginalKeyBindings[J] = CurrentKeyBindings[J];
                ++ J;
                // [Loop Continue]
                goto J0x6C;
            }
            bIsDirty = true;
            // [Explicit Break]
            goto J0xD6;
        }
        ++ I;
        J0xD6:
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function as_updateBind(int Index, bool bPrimary, string NewBindKey)
{
    NewBindKey = Outer.Outer.GetBindingKeyLocalizedString(NewBindKey);
    Outer.Outer.ActionScriptVoid("_root.updateBind");
    //return;    
}

function as_addKeybindDivider(int XPos, int YPos, string Label, string PrimaryLabel, string SecondaryLabel, bool bShortEnd)
{
    Label = Outer.LocalizeMenuString(Label);
    PrimaryLabel = Outer.LocalizeMenuString(PrimaryLabel);
    SecondaryLabel = Outer.LocalizeMenuString(SecondaryLabel);
    Outer.Outer.ActionScriptVoid("_root.addKeybindDivider");
    //return;    
}

function as_addKeyBind(string Command, string ToolTip, string PrimaryKey, string SecondaryKey, bool bLocked)
{
    PrimaryKey = Outer.Outer.GetBindingKeyLocalizedString(PrimaryKey);
    SecondaryKey = Outer.Outer.GetBindingKeyLocalizedString(SecondaryKey);
    // End:0xFE
    if(!class'WorldInfo'.static.IsConsoleBuild())
    {
        Outer.Outer.ActionScriptVoid("_root.addKeybindPC");
    }
    // End:0x144
    else
    {
        Outer.Outer.ActionScriptVoid("_root.addKeybind");
    }
    //return;    
}
